Index: dnspython-1.12.0/dns/rdtypes/ANY/HIP.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/HIP.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/HIP.py
@@ -13,15 +13,19 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-import cStringIO
-import string
 import struct
+import base64
+import binascii
 
 import dns.exception
 import dns.rdata
 import dns.rdatatype
+from io import BytesIO
+from dns._compat import xcmp
+
 
 class HIP(dns.rdata.Rdata):
+
     """HIP record
 
     @ivar hit: the host identity tag
@@ -44,22 +48,23 @@ class HIP(dns.rdata.Rdata):
         self.servers = servers
 
     def to_text(self, origin=None, relativize=True, **kw):
-        hit = self.hit.encode('hex-codec')
-        key = self.key.encode('base64-codec').replace('\n', '')
-        text = ''
+        hit = binascii.hexlify(self.hit).decode()
+        key = base64.b64encode(self.key).replace(b'\n', b'').decode()
+        text = u''
         servers = []
         for server in self.servers:
-            servers.append(str(server.choose_relativity(origin, relativize)))
+            servers.append(server.choose_relativity(origin, relativize))
         if len(servers) > 0:
-            text += (' ' + ' '.join(servers))
-        return '%u %s %s%s' % (self.algorithm, hit, key, text)
+            text += (u' ' + u' '.join(map(lambda x: x.to_unicode(), servers)))
+        return u'%u %s %s%s' % (self.algorithm, hit, key, text)
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         algorithm = tok.get_uint8()
-        hit = tok.get_string().decode('hex-codec')
+        hit = binascii.unhexlify(tok.get_string().encode())
         if len(hit) > 255:
             raise dns.exception.SyntaxError("HIT too long")
-        key = tok.get_string().decode('base64-codec')
+        key = base64.b64decode(tok.get_string().encode())
         servers = []
         while 1:
             token = tok.get()
@@ -70,9 +75,7 @@ class HIP(dns.rdata.Rdata):
             servers.append(server)
         return cls(rdclass, rdtype, hit, algorithm, key, servers)
 
-    from_text = classmethod(from_text)
-
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         lh = len(self.hit)
         lk = len(self.key)
         file.write(struct.pack("!BBH", lh, self.algorithm, lk))
@@ -81,15 +84,16 @@ class HIP(dns.rdata.Rdata):
         for server in self.servers:
             server.to_wire(file, None, origin)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
         (lh, algorithm, lk) = struct.unpack('!BBH',
-                                            wire[current : current + 4])
+                                            wire[current: current + 4])
         current += 4
         rdlen -= 4
-        hit = wire[current : current + lh].unwrap()
+        hit = wire[current: current + lh].unwrap()
         current += lh
         rdlen -= lh
-        key = wire[current : current + lk].unwrap()
+        key = wire[current: current + lk].unwrap()
         current += lk
         rdlen -= lk
         servers = []
@@ -98,14 +102,12 @@ class HIP(dns.rdata.Rdata):
                                                  current)
             current += cused
             rdlen -= cused
-            if not origin is None:
+            if origin is not None:
                 server = server.relativize(origin)
             servers.append(server)
         return cls(rdclass, rdtype, hit, algorithm, key, servers)
 
-    from_wire = classmethod(from_wire)
-
-    def choose_relativity(self, origin = None, relativize = True):
+    def choose_relativity(self, origin=None, relativize=True):
         servers = []
         for server in self.servers:
             server = server.choose_relativity(origin, relativize)
@@ -113,19 +115,19 @@ class HIP(dns.rdata.Rdata):
         self.servers = servers
 
     def _cmp(self, other):
-        b1 = cStringIO.StringIO()
+        b1 = BytesIO()
         lh = len(self.hit)
         lk = len(self.key)
         b1.write(struct.pack("!BBH", lh, self.algorithm, lk))
         b1.write(self.hit)
         b1.write(self.key)
-        b2 = cStringIO.StringIO()
+        b2 = BytesIO()
         lh = len(other.hit)
         lk = len(other.key)
         b2.write(struct.pack("!BBH", lh, other.algorithm, lk))
         b2.write(other.hit)
         b2.write(other.key)
-        v = cmp(b1.getvalue(), b2.getvalue())
+        v = xcmp(b1.getvalue(), b2.getvalue())
         if v != 0:
             return v
         ls = len(self.servers)
@@ -133,7 +135,7 @@ class HIP(dns.rdata.Rdata):
         count = min(ls, lo)
         i = 0
         while i < count:
-            v = cmp(self.servers[i], other.servers[i])
+            v = xcmp(self.servers[i], other.servers[i])
             if v != 0:
                 return v
             i += 1
Index: dnspython-1.12.0/dns/rdtypes/ANY/ISDN.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/ISDN.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/ISDN.py
@@ -13,11 +13,17 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
+import struct
+
 import dns.exception
 import dns.rdata
 import dns.tokenizer
+from dns._compat import text_type
+from dns._compat import xcmp
+
 
 class ISDN(dns.rdata.Rdata):
+
     """ISDN record
 
     @ivar address: the ISDN address
@@ -30,8 +36,14 @@ class ISDN(dns.rdata.Rdata):
 
     def __init__(self, rdclass, rdtype, address, subaddress):
         super(ISDN, self).__init__(rdclass, rdtype)
-        self.address = address
-        self.subaddress = subaddress
+        if isinstance(address, text_type):
+            self.address = address.encode()
+        else:
+            self.address = address
+        if isinstance(address, text_type):
+            self.subaddress = subaddress.encode()
+        else:
+            self.subaddress = subaddress
 
     def to_text(self, origin=None, relativize=True, **kw):
         if self.subaddress:
@@ -40,7 +52,8 @@ class ISDN(dns.rdata.Rdata):
         else:
             return '"%s"' % dns.rdata._escapify(self.address)
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         address = tok.get_string()
         t = tok.get()
         if not t.is_eol_or_eof():
@@ -52,23 +65,20 @@ class ISDN(dns.rdata.Rdata):
         tok.get_eol()
         return cls(rdclass, rdtype, address, subaddress)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         l = len(self.address)
         assert l < 256
-        byte = chr(l)
-        file.write(byte)
+        file.write(struct.pack('!B', l))
         file.write(self.address)
         l = len(self.subaddress)
         if l > 0:
             assert l < 256
-            byte = chr(l)
-            file.write(byte)
+            file.write(struct.pack('!B', l))
             file.write(self.subaddress)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
-        l = ord(wire[current])
+        l = wire[current]
         current += 1
         rdlen -= 1
         if l > rdlen:
@@ -77,7 +87,7 @@ class ISDN(dns.rdata.Rdata):
         current += l
         rdlen -= l
         if rdlen > 0:
-            l = ord(wire[current])
+            l = wire[current]
             current += 1
             rdlen -= 1
             if l != rdlen:
@@ -87,10 +97,8 @@ class ISDN(dns.rdata.Rdata):
             subaddress = ''
         return cls(rdclass, rdtype, address, subaddress)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        v = cmp(self.address, other.address)
+        v = xcmp(self.address, other.address)
         if v == 0:
-            v = cmp(self.subaddress, other.subaddress)
+            v = xcmp(self.subaddress, other.subaddress)
         return v
Index: dnspython-1.12.0/dns/rdtypes/ANY/LOC.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/LOC.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/LOC.py
@@ -13,32 +13,36 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-import cStringIO
 import struct
 
 import dns.exception
 import dns.rdata
+from dns._compat import long, xrange
+from io import BytesIO
+from dns._compat import xcmp
 
-_pows = (1L, 10L, 100L, 1000L, 10000L, 100000L, 1000000L, 10000000L,
-         100000000L, 1000000000L, 10000000000L)
+
+_pows = tuple(long(10**i) for i in range(0, 11))
 
 # default values are in centimeters
 _default_size = 100.0
 _default_hprec = 1000000.0
 _default_vprec = 1000.0
 
+
 def _exponent_of(what, desc):
     if what == 0:
         return 0
     exp = None
     for i in xrange(len(_pows)):
-        if what // _pows[i] == 0L:
+        if what // _pows[i] == long(0):
             exp = i - 1
             break
     if exp is None or exp < 0:
         raise dns.exception.SyntaxError("%s value out of bounds" % desc)
     return exp
 
+
 def _float_to_tuple(what):
     if what < 0:
         sign = -1
@@ -55,6 +59,7 @@ def _float_to_tuple(what):
     what = int(what)
     return (degrees * sign, minutes, seconds, what)
 
+
 def _tuple_to_float(what):
     if what[0] < 0:
         sign = -1
@@ -67,12 +72,14 @@ def _tuple_to_float(what):
     value += float(what[3]) / 3600000.0
     return sign * value
 
+
 def _encode_size(what, desc):
-    what = long(what);
+    what = long(what)
     exponent = _exponent_of(what, desc) & 0xF
     base = what // pow(10, exponent) & 0xF
     return base * 16 + exponent
 
+
 def _decode_size(what, desc):
     exponent = what & 0x0F
     if exponent > 9:
@@ -82,7 +89,9 @@ def _decode_size(what, desc):
         raise dns.exception.SyntaxError("bad %s base" % desc)
     return long(base) * pow(10, exponent)
 
+
 class LOC(dns.rdata.Rdata):
+
     """LOC record
 
     @ivar latitude: latitude
@@ -105,7 +114,8 @@ class LOC(dns.rdata.Rdata):
                  'horizontal_precision', 'vertical_precision']
 
     def __init__(self, rdclass, rdtype, latitude, longitude, altitude,
-                 size=_default_size, hprec=_default_hprec, vprec=_default_vprec):
+                 size=_default_size, hprec=_default_hprec,
+                 vprec=_default_vprec):
         """Initialize a LOC record instance.
 
         The parameters I{latitude} and I{longitude} may be either a 4-tuple
@@ -147,19 +157,20 @@ class LOC(dns.rdata.Rdata):
             lat_degrees, self.latitude[1], self.latitude[2], self.latitude[3],
             lat_hemisphere, long_degrees, self.longitude[1], self.longitude[2],
             self.longitude[3], long_hemisphere, self.altitude / 100.0
-            )
+        )
 
         # do not print default values
         if self.size != _default_size or \
             self.horizontal_precision != _default_hprec or \
-            self.vertical_precision != _default_vprec:
+                self.vertical_precision != _default_vprec:
             text += " %0.2fm %0.2fm %0.2fm" % (
                 self.size / 100.0, self.horizontal_precision / 100.0,
                 self.vertical_precision / 100.0
             )
         return text
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         latitude = [0, 0, 0, 0]
         longitude = [0, 0, 0, 0]
         size = _default_size
@@ -174,13 +185,15 @@ class LOC(dns.rdata.Rdata):
             if '.' in t:
                 (seconds, milliseconds) = t.split('.')
                 if not seconds.isdigit():
-                    raise dns.exception.SyntaxError('bad latitude seconds value')
+                    raise dns.exception.SyntaxError(
+                        'bad latitude seconds value')
                 latitude[2] = int(seconds)
                 if latitude[2] >= 60:
                     raise dns.exception.SyntaxError('latitude seconds >= 60')
                 l = len(milliseconds)
                 if l == 0 or l > 3 or not milliseconds.isdigit():
-                    raise dns.exception.SyntaxError('bad latitude milliseconds value')
+                    raise dns.exception.SyntaxError(
+                        'bad latitude milliseconds value')
                 if l == 1:
                     m = 100
                 elif l == 2:
@@ -205,13 +218,15 @@ class LOC(dns.rdata.Rdata):
             if '.' in t:
                 (seconds, milliseconds) = t.split('.')
                 if not seconds.isdigit():
-                    raise dns.exception.SyntaxError('bad longitude seconds value')
+                    raise dns.exception.SyntaxError(
+                        'bad longitude seconds value')
                 longitude[2] = int(seconds)
                 if longitude[2] >= 60:
                     raise dns.exception.SyntaxError('longitude seconds >= 60')
                 l = len(milliseconds)
                 if l == 0 or l > 3 or not milliseconds.isdigit():
-                    raise dns.exception.SyntaxError('bad longitude milliseconds value')
+                    raise dns.exception.SyntaxError(
+                        'bad longitude milliseconds value')
                 if l == 1:
                     m = 100
                 elif l == 2:
@@ -256,7 +271,6 @@ class LOC(dns.rdata.Rdata):
         return cls(rdclass, rdtype, latitude, longitude, altitude,
                    size, hprec, vprec)
 
-    from_text = classmethod(from_text)
 
     def to_wire(self, file, compress = None, origin = None):
         if self.latitude[0] < 0:
@@ -269,7 +283,7 @@ class LOC(dns.rdata.Rdata):
                         self.latitude[1] * 60000 +
                         self.latitude[2] * 1000 +
                         self.latitude[3]) * sign
-        latitude = 0x80000000L + milliseconds
+        latitude = long(0x80000000) + milliseconds
         if self.longitude[0] < 0:
             sign = -1
             degrees = long(-1 * self.longitude[0])
@@ -280,8 +294,8 @@ class LOC(dns.rdata.Rdata):
                         self.longitude[1] * 60000 +
                         self.longitude[2] * 1000 +
                         self.longitude[3]) * sign
-        longitude = 0x80000000L + milliseconds
-        altitude = long(self.altitude) + 10000000L
+        longitude = long(0x80000000) + milliseconds
+        altitude = long(self.altitude) + long(10000000)
         size = _encode_size(self.size, "size")
         hprec = _encode_size(self.horizontal_precision, "horizontal precision")
         vprec = _encode_size(self.vertical_precision, "vertical precision")
@@ -289,19 +303,20 @@ class LOC(dns.rdata.Rdata):
                            longitude, altitude)
         file.write(wire)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
         (version, size, hprec, vprec, latitude, longitude, altitude) = \
-                  struct.unpack("!BBBBIII", wire[current : current + rdlen])
-        if latitude > 0x80000000L:
-            latitude = float(latitude - 0x80000000L) / 3600000
+            struct.unpack("!BBBBIII", wire[current: current + rdlen])
+        if latitude > long(0x80000000):
+            latitude = float(latitude - long(0x80000000)) / 3600000
         else:
-            latitude = -1 * float(0x80000000L - latitude) / 3600000
+            latitude = -1 * float(long(0x80000000) - latitude) / 3600000
         if latitude < -90.0 or latitude > 90.0:
             raise dns.exception.FormError("bad latitude")
-        if longitude > 0x80000000L:
-            longitude = float(longitude - 0x80000000L) / 3600000
+        if longitude > long(0x80000000):
+            longitude = float(longitude - long(0x80000000)) / 3600000
         else:
-            longitude = -1 * float(0x80000000L - longitude) / 3600000
+            longitude = -1 * float(long(0x80000000) - longitude) / 3600000
         if longitude < -180.0 or longitude > 180.0:
             raise dns.exception.FormError("bad longitude")
         altitude = float(altitude) - 10000000.0
@@ -311,10 +326,8 @@ class LOC(dns.rdata.Rdata):
         return cls(rdclass, rdtype, latitude, longitude, altitude,
                    size, hprec, vprec)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        f = cStringIO.StringIO()
+        f = BytesIO()
         self.to_wire(f)
         wire1 = f.getvalue()
         f.seek(0)
@@ -323,7 +336,7 @@ class LOC(dns.rdata.Rdata):
         wire2 = f.getvalue()
         f.close()
 
-        return cmp(wire1, wire2)
+        return xcmp(wire1, wire2)
 
     def _get_float_latitude(self):
         return _tuple_to_float(self.latitude)
Index: dnspython-1.12.0/dns/rdtypes/ANY/NSEC.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/NSEC.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/NSEC.py
@@ -13,14 +13,17 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-import cStringIO
+import struct
 
 import dns.exception
 import dns.rdata
 import dns.rdatatype
 import dns.name
+from dns._compat import xrange
+
 
 class NSEC(dns.rdata.Rdata):
+
     """NSEC record
 
     @ivar next: the next name
@@ -41,15 +44,16 @@ class NSEC(dns.rdata.Rdata):
         for (window, bitmap) in self.windows:
             bits = []
             for i in xrange(0, len(bitmap)):
-                byte = ord(bitmap[i])
+                byte = bitmap[i]
                 for j in xrange(0, 8):
                     if byte & (0x80 >> j):
-                        bits.append(dns.rdatatype.to_text(window * 256 + \
+                        bits.append(dns.rdatatype.to_text(window * 256 +
                                                           i * 8 + j))
             text += (' ' + ' '.join(bits))
         return '%s%s' % (next, text)
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         next = tok.get_name()
         next = next.choose_relativity(origin, relativize)
         rdtypes = []
@@ -67,7 +71,7 @@ class NSEC(dns.rdata.Rdata):
         window = 0
         octets = 0
         prior_rdtype = 0
-        bitmap = ['\0'] * 32
+        bitmap = bytearray(b'\0' * 32)
         windows = []
         for nrdtype in rdtypes:
             if nrdtype == prior_rdtype:
@@ -75,27 +79,26 @@ class NSEC(dns.rdata.Rdata):
             prior_rdtype = nrdtype
             new_window = nrdtype // 256
             if new_window != window:
-                windows.append((window, ''.join(bitmap[0:octets])))
-                bitmap = ['\0'] * 32
+                windows.append((window, bitmap[0:octets]))
+                bitmap = bytearray(b'\0' * 32)
                 window = new_window
             offset = nrdtype % 256
             byte = offset // 8
             bit = offset % 8
             octets = byte + 1
-            bitmap[byte] = chr(ord(bitmap[byte]) | (0x80 >> bit))
-        windows.append((window, ''.join(bitmap[0:octets])))
-        return cls(rdclass, rdtype, next, windows)
+            bitmap[byte] = bitmap[byte] | (0x80 >> bit)
 
-    from_text = classmethod(from_text)
+        windows.append((window, bitmap[0:octets]))
+        return cls(rdclass, rdtype, next, windows)
 
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         self.next.to_wire(file, None, origin)
         for (window, bitmap) in self.windows:
-            file.write(chr(window))
-            file.write(chr(len(bitmap)))
+            file.write(struct.pack('!BB', window, len(bitmap)))
             file.write(bitmap)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
         (next, cused) = dns.name.from_wire(wire[: current + rdlen], current)
         current += cused
         rdlen -= cused
@@ -103,25 +106,23 @@ class NSEC(dns.rdata.Rdata):
         while rdlen > 0:
             if rdlen < 3:
                 raise dns.exception.FormError("NSEC too short")
-            window = ord(wire[current])
-            octets = ord(wire[current + 1])
+            window = wire[current]
+            octets = wire[current + 1]
             if octets == 0 or octets > 32:
                 raise dns.exception.FormError("bad NSEC octets")
             current += 2
             rdlen -= 2
             if rdlen < octets:
                 raise dns.exception.FormError("bad NSEC bitmap length")
-            bitmap = wire[current : current + octets].unwrap()
+            bitmap = bytearray(wire[current: current + octets].unwrap())
             current += octets
             rdlen -= octets
             windows.append((window, bitmap))
-        if not origin is None:
+        if origin is not None:
             next = next.relativize(origin)
         return cls(rdclass, rdtype, next, windows)
 
-    from_wire = classmethod(from_wire)
-
-    def choose_relativity(self, origin = None, relativize = True):
+    def choose_relativity(self, origin=None, relativize=True):
         self.next = self.next.choose_relativity(origin, relativize)
 
     def _cmp(self, other):
Index: dnspython-1.12.0/dns/rdtypes/ANY/NSEC3.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/NSEC3.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/NSEC3.py
@@ -13,19 +13,28 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
+from io import BytesIO
 import base64
-import cStringIO
+import binascii
 import string
 import struct
 
 import dns.exception
 import dns.rdata
 import dns.rdatatype
+from dns._compat import xrange, text_type
+from dns._compat import xcmp
 
-b32_hex_to_normal = string.maketrans('0123456789ABCDEFGHIJKLMNOPQRSTUV',
-                                     'ABCDEFGHIJKLMNOPQRSTUVWXYZ234567')
-b32_normal_to_hex = string.maketrans('ABCDEFGHIJKLMNOPQRSTUVWXYZ234567',
-                                     '0123456789ABCDEFGHIJKLMNOPQRSTUV')
+try:
+    b32_hex_to_normal = string.maketrans('0123456789ABCDEFGHIJKLMNOPQRSTUV',
+                                         'ABCDEFGHIJKLMNOPQRSTUVWXYZ234567')
+    b32_normal_to_hex = string.maketrans('ABCDEFGHIJKLMNOPQRSTUVWXYZ234567',
+                                         '0123456789ABCDEFGHIJKLMNOPQRSTUV')
+except AttributeError:
+    b32_hex_to_normal = bytes.maketrans(b'0123456789ABCDEFGHIJKLMNOPQRSTUV',
+                                        b'ABCDEFGHIJKLMNOPQRSTUVWXYZ234567')
+    b32_normal_to_hex = bytes.maketrans(b'ABCDEFGHIJKLMNOPQRSTUVWXYZ234567',
+                                        b'0123456789ABCDEFGHIJKLMNOPQRSTUV')
 
 # hash algorithm constants
 SHA1 = 1
@@ -33,7 +42,9 @@ SHA1 = 1
 # flag constants
 OPTOUT = 1
 
+
 class NSEC3(dns.rdata.Rdata):
+
     """NSEC3 record
 
     @ivar algorithm: the hash algorithm number
@@ -57,39 +68,45 @@ class NSEC3(dns.rdata.Rdata):
         self.algorithm = algorithm
         self.flags = flags
         self.iterations = iterations
-        self.salt = salt
+        if isinstance(salt, text_type):
+            self.salt = salt.encode()
+        else:
+            self.salt = salt
         self.next = next
         self.windows = windows
 
     def to_text(self, origin=None, relativize=True, **kw):
-        next = base64.b32encode(self.next).translate(b32_normal_to_hex).lower()
-        if self.salt == '':
+        next = base64.b32encode(self.next).translate(
+            b32_normal_to_hex).lower().decode()
+        if self.salt == b'':
             salt = '-'
         else:
-            salt = self.salt.encode('hex-codec')
-        text = ''
+            salt = binascii.hexlify(self.salt).decode()
+        text = u''
         for (window, bitmap) in self.windows:
             bits = []
             for i in xrange(0, len(bitmap)):
-                byte = ord(bitmap[i])
+                byte = bitmap[i]
                 for j in xrange(0, 8):
                     if byte & (0x80 >> j):
-                        bits.append(dns.rdatatype.to_text(window * 256 + \
+                        bits.append(dns.rdatatype.to_text(window * 256 +
                                                           i * 8 + j))
-            text += (' ' + ' '.join(bits))
-        return '%u %u %u %s %s%s' % (self.algorithm, self.flags, self.iterations,
-                                     salt, next, text)
+            text += (u' ' + u' '.join(bits))
+        return u'%u %u %u %s %s%s' % (self.algorithm, self.flags,
+                                      self.iterations, salt, next, text)
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         algorithm = tok.get_uint8()
         flags = tok.get_uint8()
         iterations = tok.get_uint16()
         salt = tok.get_string()
-        if salt == '-':
-            salt = ''
+        if salt == u'-':
+            salt = b''
         else:
-            salt = salt.decode('hex-codec')
-        next = tok.get_string().upper().translate(b32_hex_to_normal)
+            salt = binascii.unhexlify(salt.encode('ascii'))
+        next = tok.get_string().encode(
+            'ascii').upper().translate(b32_hex_to_normal)
         next = base64.b32decode(next)
         rdtypes = []
         while 1:
@@ -106,7 +123,7 @@ class NSEC3(dns.rdata.Rdata):
         window = 0
         octets = 0
         prior_rdtype = 0
-        bitmap = ['\0'] * 32
+        bitmap = bytearray(b'\0' * 32)
         windows = []
         for nrdtype in rdtypes:
             if nrdtype == prior_rdtype:
@@ -116,20 +133,19 @@ class NSEC3(dns.rdata.Rdata):
             if new_window != window:
                 if octets != 0:
                     windows.append((window, ''.join(bitmap[0:octets])))
-                bitmap = ['\0'] * 32
+                bitmap = bytearray(b'\0' * 32)
                 window = new_window
             offset = nrdtype % 256
             byte = offset // 8
             bit = offset % 8
             octets = byte + 1
-            bitmap[byte] = chr(ord(bitmap[byte]) | (0x80 >> bit))
+            bitmap[byte] = bitmap[byte] | (0x80 >> bit)
         if octets != 0:
-            windows.append((window, ''.join(bitmap[0:octets])))
-        return cls(rdclass, rdtype, algorithm, flags, iterations, salt, next, windows)
-
-    from_text = classmethod(from_text)
+            windows.append((window, bitmap[0:octets]))
+        return cls(rdclass, rdtype, algorithm, flags, iterations, salt, next,
+                   windows)
 
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         l = len(self.salt)
         file.write(struct.pack("!BBHB", self.algorithm, self.flags,
                                self.iterations, l))
@@ -138,19 +154,19 @@ class NSEC3(dns.rdata.Rdata):
         file.write(struct.pack("!B", l))
         file.write(self.next)
         for (window, bitmap) in self.windows:
-            file.write(chr(window))
-            file.write(chr(len(bitmap)))
+            file.write(struct.pack("!BB", window, len(bitmap)))
             file.write(bitmap)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
-        (algorithm, flags, iterations, slen) = struct.unpack('!BBHB',
-                                                             wire[current : current + 5])
+        (algorithm, flags, iterations, slen) = \
+            struct.unpack('!BBHB', wire[current: current + 5])
         current += 5
         rdlen -= 5
         salt = wire[current : current + slen].unwrap()
         current += slen
         rdlen -= slen
-        (nlen, ) = struct.unpack('!B', wire[current])
+        nlen = wire[current]
         current += 1
         rdlen -= 1
         next = wire[current : current + nlen].unwrap()
@@ -160,25 +176,23 @@ class NSEC3(dns.rdata.Rdata):
         while rdlen > 0:
             if rdlen < 3:
                 raise dns.exception.FormError("NSEC3 too short")
-            window = ord(wire[current])
-            octets = ord(wire[current + 1])
+            window = wire[current]
+            octets = wire[current + 1]
             if octets == 0 or octets > 32:
                 raise dns.exception.FormError("bad NSEC3 octets")
             current += 2
             rdlen -= 2
             if rdlen < octets:
                 raise dns.exception.FormError("bad NSEC3 bitmap length")
-            bitmap = wire[current : current + octets].unwrap()
+            bitmap = bytearray(wire[current: current + octets].unwrap())
             current += octets
             rdlen -= octets
             windows.append((window, bitmap))
         return cls(rdclass, rdtype, algorithm, flags, iterations, salt, next, windows)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        b1 = cStringIO.StringIO()
+        b1 = BytesIO()
         self.to_wire(b1)
-        b2 = cStringIO.StringIO()
+        b2 = BytesIO()
         other.to_wire(b2)
-        return cmp(b1.getvalue(), b2.getvalue())
+        return xcmp(b1.getvalue(), b2.getvalue())
